diff --git a/drivers/gpu/drm/amd/include/amd_shared.h b/drivers/gpu/drm/amd/include/amd_shared.h
index 4c95b885d1d0..7074ec3b467f 100644
--- a/drivers/gpu/drm/amd/include/amd_shared.h
+++ b/drivers/gpu/drm/amd/include/amd_shared.h
@@ -255,120 +255,60 @@ enum DC_FEATURE_MASK {
 
 /**
  * enum DC_DEBUG_MASK - Bits that are useful for debugging the Display Core IP
+ * @DC_DISABLE_PIPE_SPLIT: If set, disable pipe-splitting
+ * @DC_DISABLE_STUTTER: If set, disable memory stutter mode
+ * @DC_DISABLE_DSC: If set, disable display stream compression
+ * @DC_DISABLE_CLOCK_GATING: If set, disable clock gating optimizations
+ * @DC_DISABLE_PSR: If set, disable Panel self refresh v1 and PSR-SU
+ * @DC_FORCE_SUBVP_MCLK_SWITCH: If set, force mclk switch in subvp, even
+ *	 							if mclk switch in vblank is possible
+ * @DC_DISABLE_MPO: If set, disable multi-plane offloading
+ * @DC_ENABLE_DPIA_TRACE: If set, enable trace logging for DPIA
+ * @DC_ENABLE_DML2: If set, force usage of DML2, even if the DCN version
+ *	 				does not default to it.
+ * @DC_DISABLE_PSR_SU: If set, disable PSR SU
+ * @DC_DISABLE_REPLAY: If set, disable Panel Replay
+ * @DC_DISABLE_IPS: If set, disable all Idle Power States, all the time.
+ *	 				If more than one IPS debug bit is set, the lowest bit takes
+ *	 				precedence. For example, if DC_FORCE_IPS_ENABLE and
+ *	 				DC_DISABLE_IPS_DYNAMIC are set, then DC_DISABLE_IPS_DYNAMIC takes
+ *	 				precedence.
+ * @DC_DISABLE_IPS_DYNAMIC: If set, disable all IPS, all the time,
+ *	 						*except* when driver goes into suspend.
+ * @DC_DISABLE_IPS2_DYNAMIC: If set, disable IPS2 (IPS1 allowed) if
+ *	 						there is an enabled display. Otherwise, enable all IPS.
+ * @DC_FORCE_IPS_ENABLE: If set, force enable all IPS, all the time.
+ * @DC_DISABLE_ACPI_EDID: If set, don't attempt to fetch EDID for
+ *	 					  eDP display from ACPI _DDC method.
+ * @DC_DISABLE_HDMI_CEC: If set, disable HDMI-CEC feature in amdgpu driver.
+ * @DC_DISABLE_SUBVP: If set, disable DCN Sub-Viewport feature in amdgpu driver.
+ * @DC_DISABLE_CUSTOM_BRIGHTNESS_CURVE: If set, disable support for custom brightness curves
+ * @DC_HDCP_LC_FORCE_FW_ENABLE: If set, use HDCP Locality Check FW
+ *	 					        path regardless of reported HW capabilities.
+ * @DC_HDCP_LC_ENABLE_SW_FALLBACK: If set, upon HDCP Locality Check FW
+ *	                              path failure, retry using legacy SW path.
  */
 enum DC_DEBUG_MASK {
-	/**
-	 * @DC_DISABLE_PIPE_SPLIT: If set, disable pipe-splitting
-	 */
 	DC_DISABLE_PIPE_SPLIT = 0x1,
-
-	/**
-	 * @DC_DISABLE_STUTTER: If set, disable memory stutter mode
-	 */
 	DC_DISABLE_STUTTER = 0x2,
-
-	/**
-	 * @DC_DISABLE_DSC: If set, disable display stream compression
-	 */
 	DC_DISABLE_DSC = 0x4,
-
-	/**
-	 * @DC_DISABLE_CLOCK_GATING: If set, disable clock gating optimizations
-	 */
 	DC_DISABLE_CLOCK_GATING = 0x8,
-
-	/**
-	 * @DC_DISABLE_PSR: If set, disable Panel self refresh v1 and PSR-SU
-	 */
 	DC_DISABLE_PSR = 0x10,
-
-	/**
-	 * @DC_FORCE_SUBVP_MCLK_SWITCH: If set, force mclk switch in subvp, even
-	 * if mclk switch in vblank is possible
-	 */
 	DC_FORCE_SUBVP_MCLK_SWITCH = 0x20,
-
-	/**
-	 * @DC_DISABLE_MPO: If set, disable multi-plane offloading
-	 */
 	DC_DISABLE_MPO = 0x40,
-
-	/**
-	 * @DC_ENABLE_DPIA_TRACE: If set, enable trace logging for DPIA
-	 */
 	DC_ENABLE_DPIA_TRACE = 0x80,
-
-	/**
-	 * @DC_ENABLE_DML2: If set, force usage of DML2, even if the DCN version
-	 * does not default to it.
-	 */
 	DC_ENABLE_DML2 = 0x100,
-
-	/**
-	 * @DC_DISABLE_PSR_SU: If set, disable PSR SU
-	 */
 	DC_DISABLE_PSR_SU = 0x200,
-
-	/**
-	 * @DC_DISABLE_REPLAY: If set, disable Panel Replay
-	 */
 	DC_DISABLE_REPLAY = 0x400,
-
-	/**
-	 * @DC_DISABLE_IPS: If set, disable all Idle Power States, all the time.
-	 * If more than one IPS debug bit is set, the lowest bit takes
-	 * precedence. For example, if DC_FORCE_IPS_ENABLE and
-	 * DC_DISABLE_IPS_DYNAMIC are set, then DC_DISABLE_IPS_DYNAMIC takes
-	 * precedence.
-	 */
 	DC_DISABLE_IPS = 0x800,
-
-	/**
-	 * @DC_DISABLE_IPS_DYNAMIC: If set, disable all IPS, all the time,
-	 * *except* when driver goes into suspend.
-	 */
 	DC_DISABLE_IPS_DYNAMIC = 0x1000,
-
-	/**
-	 * @DC_DISABLE_IPS2_DYNAMIC: If set, disable IPS2 (IPS1 allowed) if
-	 * there is an enabled display. Otherwise, enable all IPS.
-	 */
 	DC_DISABLE_IPS2_DYNAMIC = 0x2000,
-
-	/**
-	 * @DC_FORCE_IPS_ENABLE: If set, force enable all IPS, all the time.
-	 */
 	DC_FORCE_IPS_ENABLE = 0x4000,
-	/**
-	 * @DC_DISABLE_ACPI_EDID: If set, don't attempt to fetch EDID for
-	 * eDP display from ACPI _DDC method.
-	 */
 	DC_DISABLE_ACPI_EDID = 0x8000,
-
-	/**
-	 * @DC_DISABLE_HDMI_CEC: If set, disable HDMI-CEC feature in amdgpu driver.
-	 */
 	DC_DISABLE_HDMI_CEC = 0x10000,
-
-	/**
-	 * @DC_DISABLE_SUBVP: If set, disable DCN Sub-Viewport feature in amdgpu driver.
-	 */
 	DC_DISABLE_SUBVP = 0x20000,
-	/**
-	 * @DC_DISABLE_CUSTOM_BRIGHTNESS_CURVE: If set, disable support for custom brightness curves
-	 */
 	DC_DISABLE_CUSTOM_BRIGHTNESS_CURVE = 0x40000,
-
-	/**
-	 * @DC_HDCP_LC_FORCE_FW_ENABLE: If set, use HDCP Locality Check FW
-	 * path regardless of reported HW capabilities.
-	 */
 	DC_HDCP_LC_FORCE_FW_ENABLE = 0x80000,
-
-	/**
-	 * @DC_HDCP_LC_ENABLE_SW_FALLBACK If set, upon HDCP Locality Check FW
-	 * path failure, retry using legacy SW path.
-	 */
 	DC_HDCP_LC_ENABLE_SW_FALLBACK = 0x100000,
 };
 